/* Some functions are unused, because i first intented to design the program
   a different way, but then realised this design is alot better

   How to use this:

   ftpbounce foo.bar.com/incoming/file.txt put
   -------------------------------------------
   this would open a port on foo.bar.com, putting anything
   sent to it to the file /incoming/file.txt

   
   ftpbounce foo.bar.com/incoming/file.txt get
   -------------------------------------------
   this would open a port on foo.bar.com, dumping everything
   from /incoming/file.txt to whomever connects there


   ftpbounce foo.bar.com/incoming/file.txt bar.foo.com 4500 put
   ------------------------------------------------------------
   this would connect to bar.foo.com on port 4500, downloading
   everything from it to /incoming/file.txt on foo.bar.com


   ftpbounce foo.bar.com/incoming/file.txt bar.foo.com 4500 get
   ------------------------------------------------------------
   this would connect to bar.foo.com on port 4500, uploading
   everything from /incoming/file.txt on foo.bar.com to bar.foo.com

*/

#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <string.h>
#include <pwd.h>
#include <getopt.h>

#include "urltoaddr.h"

static char rcsid[] = "$Id: ftpbounce.c,v 1.25 1999/05/10 17:13:40 laqritz Exp $";

/* $Log: ftpbounce.c,v $
 * Revision 1.25  1999/05/10 17:13:40  laqritz
 * modified to use getopt(), and to use binary transfer, and be easier to use..
 *
 * Revision 1.24  1998/11/04 02:09:54  laqritz
 * removed a stupid rcs header.. grr..
 *
 * Revision 1.23  1998/11/04 02:07:35  laqritz
 * added another comment
 *
 * Revision 1.22  1998/11/04 01:55:53  laqritz
 * we now show the reason why login failed
 * FTPBounce Commander, by flipflop@swipnet.se
 * MODE: GET
 * Server OPEN
 * Username 'anonymous' was not accepted, trying manual login.
 * 530-Sorry, there are too many anonymous users using the system at this
 * 530-time.  Please try again later.  There is currently a limit of 2
 * 530-anonymous users.
 * 530 User anonymous access denied.
 * Enter username: ftp
 * Enter password:
 * Username 'ftp' was not accepted, trying again.
 * Enter username: anonymous
 * Enter password:
 *
 * but only the first time
 *
 * Revision 1.21  1998/11/04 01:06:31  laqritz
 * changed usage() to better describe how to use this.
 *
 * Revision 1.2  1998/11/04 01:02:14  laqritz
 * added some comments
 *
 * Revision 1.1  1998/11/04 00:41:32  laqritz
 * Initial revision
 * */

void usage(void);
int readcommands(void);
int writecommands(int sock);
char *genportcmd(char *cmd);
int parsecmd(void);
int ftp_connect(char *, unsigned short);
int ftp_login(int sock);
char *net_recv(int sock);
int net_send(int sock, char *msg);
void perform(int sock);
int show_reason=1;

#define ANON 1
#define DYNAMICCMD 1 /* this is not in use right now */
#define ANONUSER "anonymous" /* The username of the anonymous user */
#define ANONPASS "root@localhost.com" /* This is the passwd to use as anon user */

/* #define DEBUG /* Uncomment to get debugmode */

#define TRANSFER_ASCII 0
#define TRANSFER_BINARY 1

#define MODE_GET 0
#define MODE_PUT 1

struct input
{
  char *command;
  struct input *next;
};
struct input *cmd;

struct url *hostinfo;
char *remote_host=NULL;
char *remote_port=NULL;
int sender=0;
int mode=MODE_GET;
int transfer_type=TRANSFER_BINARY; /* Binary by default */
char pasvoutput[128];

int main(int ac, char **av)
{
  int sock;
  int i;

  printf("%s\n", rcsid);
  printf("FTPBounce Commander, by Martin C. <flipflop@swipnet.se>\n");
  
  /* Options and such */
  if (ac < 2)
    usage();
  
  hostinfo = urltoaddr(av[1]);

  while ((i=getopt(ac, av, "absrh:")) != EOF)
    switch(i)
      {
      case 'h':
	sender=1;
	remote_host=optarg;
	remote_port=rindex(remote_host, ',')+1;
	if (!remote_port) remote_port="21";
	strtok(remote_host, ","); /* feeling destructive */
	break;

      case 'b':
	transfer_type=TRANSFER_BINARY;
	break;
	
      case 'a':
	transfer_type=TRANSFER_ASCII;
	break;

      case 's': /* PUT */
	mode=MODE_PUT;
	break;

      case 'r': /* GET */
	mode=MODE_GET;
	break;

      default:
	break;
      }

  printf("MODE: %s\n", mode ? "PUT" : "GET");
  

  /* Do everything */
  sock = ftp_connect(hostinfo->host, hostinfo->port);
  ftp_login(sock);
  perform(sock);

  
  return 0;
  /* This was the OLD mode, no longer used */
  printf("Read %i lines\n", readcommands());
  printf("Replaced %i lines\n", parsecmd());
  printf("Wrote %i lines\n", writecommands(sock));
}

void perform(int sock)
{
  char buffer[2048];
  char portbuf[32];
  char *input;

  bzero(buffer, sizeof(buffer));

  if (transfer_type == TRANSFER_BINARY)
    snprintf(buffer, sizeof(buffer), "type i\n");
  else
    if (transfer_type == TRANSFER_ASCII)
      snprintf(buffer, sizeof(buffer), "type a\n");
  
  if (strlen(buffer) == 0)
    {
      printf("buffer[%i] is empty in %s\n", sizeof(buffer), __FUNCTION__);
      exit(255);
    }
  
  net_send(sock, buffer);
  printf("%s", net_recv(sock));

  if (sender) /* We should connect to someone else */
    {
      sprintf(buffer, "port %s:%s", remote_host, remote_port);
      sprintf(buffer, "%s\n", genportcmd(buffer));
      printf("--> %s", buffer);
      net_send(sock, buffer);
      if ((input = net_recv(sock)) != NULL) printf("<-- %s", input);
      
      sprintf(buffer, "%s %s\n", mode ? "stor": "retr", hostinfo->dir);
      printf("--> %s", buffer);
      net_send(sock, buffer);
      if ((input = net_recv(sock)) != NULL) printf("<-- %s", input);
    }
  else /* We should open a port for this file */
    {
      printf("--> pasv\n");
      net_send(sock, "pasv\n");
      while (1)
	{
	  if ((input = net_recv(sock)) != NULL) printf("<-- %s", input);
	  if (!strncmp(input, "227", 3))
	    {
	      char *pt;
	      int i;

	      pt = rindex(input, ')');
	      *pt = 0x0;
	      pt = index(input, '(') + 1;
	      
	      sprintf(buffer, "%s", pt);
	      pt = buffer;
	      for (i=0; i != 4 && *pt != '\0'; pt++) if (*pt == ',') i++;
	      pt[-1] = 0x0;
	      strtok(pt, ",");
	      i = atoi(pt) * 256;
	      pt = strtok(NULL, ",");
	      i += atoi(pt);
	      sprintf(portbuf, "%i", i);
	      strcat(buffer, ":");
	      strcat(buffer, portbuf);
	      for (i=0; i < strlen(buffer); i++)
		if (buffer[i] == ',') buffer[i]='.';
	      strcpy(pasvoutput, buffer);
	      
	      printf("PASV:%s\n", pasvoutput);
	      fflush(stdout);
	      break;
	    }
	}
      
      sprintf(buffer, "%s %s\n", mode ? "stor": "retr", hostinfo->dir);
      printf("--> %s", buffer);
      net_send(sock, buffer);
      if ((input = net_recv(sock)) != NULL) printf("<-- %s", input);
    }
  
  return;
}

int ftp_login(int sock)
{
  char *username;
  char *passwd;
  char buffer[2048];
  char *input;
  int readpass=0;
  char USER[1024];
  char PASS[1024];

  /* Setup initial value of user/pass */
  if ((username = getenv("FTPB_USER")) == NULL)
    username = ANONUSER;
  if ((passwd = getenv("FTPB_PASS")) == NULL)
    passwd = ANONPASS;

  input = net_recv(sock);
  if (input && (!strncmp(input, "220", 3) || strstr(input, "\n220")))
    printf("Server OPEN\n");
  else if (input && (!strncmp(input, "500", 3) || strstr(input, "\n500")))
    {
      printf("Server CLOSED\n");
      return -2;
    }

  /* Now log in as a user */

  while (1)
    {
      if (ANON || readpass) /* If we should try to login as anonymous first */
	{
	  sprintf(buffer, "user %s\n", username);
	  net_send(sock, buffer);
	  input = net_recv(sock);
	  if (input && (!strncmp(input, "331", 3) || strstr(input, "\n331"))) /* Send passwd also */
	    {
#ifdef DEBUG
	      printf("Username accepted\n");
#endif
	      sprintf(buffer, "pass %s\n", passwd);
	      net_send(sock, buffer);
	      input = net_recv(sock);
	      if (input && (!strncmp(input, "230", 3) || strstr(input, "\n230")))
		{
		  net_send(sock, "syst\n");
		  while (1)
		    {
		      input = net_recv(sock);
		      if (input && (!strncmp(input, "215", 3) || strstr(input, "\n215")))
			break;
		    }
		  
		  printf("Login success\n");
		  return 1; /* We are logged in */
		}
	    }
	  else
	    {
	      printf("Username '%s' was not accepted, trying %s.\n", username, readpass ? "again" : "manual login");
	      
	      while (show_reason)
		{
		  printf("%s", input);
		  input = net_recv(sock);
		  if (!input) break;
		}
	      show_reason=0;
	    }
	}
      /* Anon failed, now try manual login instead */
      printf("Enter username: ");
      fgets(USER, 1023, stdin);
      USER[strlen(USER)-1]=0x0;
      strcpy(PASS, (char *)getpass("Enter password: "));
      username = USER;
      passwd = PASS;

      readpass=1;
    }
}

int ftp_connect(char *host, unsigned short port)
{
  int sock;
  struct sockaddr_in addr;
  struct hostent *he;
  unsigned long rawhost;

  /* Setup 'addr' to use */
  addr.sin_family = AF_INET;
  addr.sin_port = htons(port);
  he = gethostbyname(host);
  if (!he)
    addr.sin_addr.s_addr = inet_addr(host);
  else
    memcpy((char *)&addr.sin_addr, he->h_addr_list[0], sizeof(struct in_addr));


  if ((sock = socket(AF_INET, SOCK_STREAM, 0)) == -1)
    {
      perror("socket");
      exit(0xff);
    }


  if (connect(sock, (struct sockaddr *)&addr, sizeof(addr)) == -1)
    {
      perror("connect");
      exit(0xff);
    }

  return sock;
}

int parsecmd(void)
{
  char *buffer;
  struct input *cmdstart = cmd;
  int replaced=0;

  while (cmd->next != NULL)
    {
      buffer = cmd->command;
      
      /* Check if we should replace any of the commands */
      if (DYNAMICCMD)
	{
	  int i;
	  char temp[strlen(buffer) + 1];
	  strcpy(temp, buffer);
	  
	  /* Convert to uppercase */
	  for (i=0; i < strlen(temp); i++)
	    temp[i] = toupper(temp[i]);
	  
	  /* strncmp() for strings we have handlers for */
	  if (!strncmp(temp, "PORT ", 5))
	    buffer = genportcmd(buffer);
	}

      /* If 'buffer' has changed, update cmd->command to the new commandline */
      if (strcmp(buffer, cmd->command))
	{
	  free(cmd->command);
	  cmd->command = (char *)malloc(strlen(buffer) + 1);
	  strcpy(cmd->command, buffer);
	  replaced++;
	}

      cmd = cmd->next;
    }
  
  cmd = cmdstart;
  return replaced;
}

char *genportcmd(char *cmd)
{
  static char retval[1024];
  struct hostent *he;
  struct in_addr addr;
  char hostbuf[strlen(cmd+strlen("port ")) + 1];
  char *host = hostbuf;
  char *port;
  int i;
  char temp[1024];
  unsigned short temp2;
  
  strcpy(hostbuf, cmd+strlen("port "));
  while (*host == ' ') host++;
  if ((port = rindex(host, ':')) != NULL || (port = rindex(host, ' ')) != NULL) port++;
  temp2 = atoi(port);
  strtok(host, ":");
  strtok(host, " ");

  he = gethostbyname(host);
  if (he)
    memcpy((char *)&addr.s_addr, he->h_addr_list[0], sizeof(struct in_addr));
  else
    addr.s_addr = inet_addr(temp);
  
  sprintf(temp, "%s,%i,%i", inet_ntoa(addr), temp2 / 256, temp2 % 256);
  for (i=0; i < strlen(temp); i++)
    if (temp[i] == '.')
      temp[i] = ',';

  sprintf(retval, "port %s", temp);

  return retval;
}

int writecommands(int sock)
{
  int i;
  char *input;
  struct input *cmdstart = cmd;
  int written=0;
  
  while (cmd->next != NULL)
    {
      printf("--> %s\n", cmd->command);

      /* Send data */
      if (net_send(sock, cmd->command) == -1) return -1;
      if (!strchr(cmd->command, '\n')) net_send(sock, "\n");

      cmd = cmd->next;
      written++;

      /* Read response */
      input = net_recv(sock);
      if (input)
	printf("<-- %s", input);
    }
    
  cmd = cmdstart;
  return written;
}

int readcommands(void)
{
  int lines=0;
  struct input *cmdstart;

  printf("Enter commands, end with a single '.' on a new line\n");

  cmd = (struct input *)malloc(sizeof(struct input *));
  cmdstart = cmd;

  do
    {
      char buffer[8192];
      bzero(buffer,8192);
      read(fileno(stdin), buffer, 8191);
      if (!strcmp(buffer, ".\n"))
	{
	  cmd->next = NULL;
	  break;
	}
      buffer[strlen(buffer)-1] = 0x0; /* Erase newlines from read buffer */

      cmd->command = (char *)malloc(strlen(buffer) + 1);
      strcpy(cmd->command, buffer);
      cmd->next = (struct input *)malloc(sizeof(struct input *));
      cmd = cmd->next;
      lines++;
    }while (1);
  
  cmd = cmdstart;

  return lines;
}

void usage(void)
{
  printf("Syntax:\n");
  
  printf("ACTIVE MODE:\n");
  printf("ftpbounce bouncerURL rhost rport [get,put]]\n\n");
  
  printf("PASV MODE:\n");
  printf("ftpbounce bouncerURL [get,put]\n");
  exit(1);
}

int net_send(int sock, char *msg)
{
  int status = send(sock, msg, strlen(msg), 0);
#ifdef DEBUG
  printf("SEND: %s\n", msg);
#endif
  return status;
}

char *net_recv(int sock)
{
  int status;
  static char buffer[2048];

  bzero(buffer,sizeof(buffer));
  if (recv(sock, buffer, sizeof(buffer)-1, 0) <= 0) return NULL;
#ifdef DEBUG
  printf("RECV: %s", buffer);
#endif
  return buffer;
}
